%define anolis_release 4
Name:           userspace-rcu
Version:        0.14.0
Release:        %{anolis_release}%{?dist}
Summary:        RCU (read-copy-update) implementation in user-space
License:        LGPLv2+
URL:            http://liburcu.org

Source0:        http://lttng.org/files/urcu/%{name}-%{version}.tar.bz2
Patch0:         regtest-without-bench.patch
Patch1:	        userspace-rcu-add-loongarch-support.patch
BuildRequires:  make
BuildRequires:  pkgconfig
BuildRequires:  perl-Test-Harness
BuildRequires:  autoconf automake libtool

%description
This data synchronization library provides read-side access which scales
linearly with the number of cores. It does so by allowing multiples copies
of a given data structure to live at the same time, and by monitoring
the data structure accesses to detect grace periods after which memory
reclamation is possible.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains libraries and header files for developing applications
that use %{name}


%prep
%autosetup -p1

%build
autoreconf -vif -W all,error

%configure --disable-static
V=1 make %{?_smp_mflags}


%install
make install DESTDIR=$RPM_BUILD_ROOT
find %{buildroot} -type f -name "*.la" -delete
rm %{buildroot}/%{_docdir}/%{name}/LICENSE
rm %{buildroot}/%{_docdir}/%{name}/README.md

%generate_compatibility_deps

%check
make check
make regtest

%ldconfig_scriptlets


%files
%dir %{abidir}
%license LICENSE gpl-2.0.txt lgpl-relicensing.txt lgpl-2.1.txt
%{_libdir}/liburcu-bp.so.8*
%{_libdir}/liburcu-cds.so.8*
%{_libdir}/liburcu-common.so.8*
%{_libdir}/liburcu-mb.so.8*
%{_libdir}/liburcu-memb.so.8*
%{_libdir}/liburcu-qsbr.so.8*
%{_libdir}/liburcu-signal.so.8*
%{_libdir}/liburcu.so.8*
%{abidir}/liburcu*.dump

%files doc
%doc ChangeLog README.md

%files devel
%doc %{_pkgdocdir}/examples
%{_includedir}/*
%{_libdir}/liburcu-bp.so
%{_libdir}/liburcu-cds.so
%{_libdir}/liburcu-common.so
%{_libdir}/liburcu-mb.so
%{_libdir}/liburcu-memb.so
%{_libdir}/liburcu-qsbr.so
%{_libdir}/liburcu-signal.so
%{_libdir}/liburcu.so
%{_libdir}/pkgconfig/liburcu*.pc
%{_docdir}/%{name}/cds-api.md
%{_docdir}/%{name}/rcu-api.md
%{_docdir}/%{name}/solaris-build.md
%{_docdir}/%{name}/uatomic-api.md


%changelog
* Tue Sep 5 2023 Jingyun Hua <huajingyun@loongson.cn> - 0.14.0-4
- Add loongarch64 support

* Tue Mar 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.14.0-3
- Del Specific Fields

* Tue Mar 28 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.14.0-2
- remove multilib related codes

* Sat Feb 25 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 0.14.0-1
- update to 0.14.0

* Thu Sep 29 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.13.0-2
- add doc package

* Wed Mar 23 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 0.13.0-1
- init from upstream
